% Compare output of Matlab and MEX implementations of LARC

test_dir = 'test/';
coh_res = 0.2;

%%

% load magnitude spectrogram and dictionary
L = load([test_dir 'speech.mat']);
X = L.Msb;
L = load([test_dir 'dict.mat']);
D = L.D;

%% Matlab Implementation
tic;
C_mat = larcmat(D, X, inf, coh_res);
toc

%% MEX Implementation

tic;
C_mex = larc(D, X, 'v', 1, 'mut', coh_res);
toc

%% Visualize

figure(1);
imagesc(log(abs(X)));
title('Original Speech');

figure(2);
imagesc(log(abs(D*C_mat)));
title('Approximated Speech (Matlab)');

figure(3);
imagesc(log(abs(D*C_mex)));
title('Approximated Speech (MEX)');

figure(4)
imagesc(abs(D*C_mex - D*C_mat));
title('Difference of Implementations');

